;*****************************************************************
;*                       PINOCCHI0  V2.2                         *
;*  (PINpointing Orbit-Crossing Collapsed HIerarchical Objects)  *
;*****************************************************************
;
;This code was written by
;Pierluigi Monaco, Tom Theuns, Giuliano Taffoni
;Copyright (C) 2008
;
;web page: http://adlibitum.oats.inaf.it/monaco/Homepage/Pinocchio/
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation; either version 2 of the License, or
;(at your option) any later version.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


retall
;.run read_planes
;.run write_planes
.run write_dens
.run readfield


; we will want to run this several times
; set size of rectangular grid
;density_file = 'Density_g1.d'
;seed = 111l
;Lx  = 64l
;Ly  = 64l
;Lz  = 64l

;  density_file = 'Density_g2.d'
;  seed = 98723l
;  Lx  = 4l
;  Ly  = 4l
;  Lz  = 8l

; density_file = 'Density_g3.d'
; seed = 34785683l
; Lx  = 64l
; Ly  = 64l
; Lz  = 64l

; generate potential
phi = double(randomu(seed,Lx,Ly,Lz))
phi = phi-mean(phi,/double)

; ;write potential field to file
; openw,unit,'phi.d',/f77_unformatted,/get_lun
; writeu,unit,long(Lx),long(Ly),long(Lz)
; for i=0,Lz-1 do writeu,unit,double(phi(*,*,i))
; close,unit
; free_lun,unit
; if key(' potential file written ') then stop
;
; compute derivatives of potential
; first derivative
dx   = (shift(phi,-1,0,0) - shift(phi,1,0,0)) / 2.0d0
dy   = (shift(phi,0,-1,0) - shift(phi,0,1,0)) / 2.0d0
dz   = (shift(phi,0,0,-1) - shift(phi,0,0,1)) / 2.0d0

; second derivatives
ddx  = shift(phi,-1,0,0) + shift(phi,1,0,0)  -2.*phi
ddy  = shift(phi,0,-1,0) + shift(phi,0,1,0)  -2.*phi
ddz  = shift(phi,0,0,-1) + shift(phi,0,0,1)  -2.*phi
dxdy = 0.5*(shift(phi,1,1,0) + shift(phi,-1,-1,0) - shift(phi,1,-1,0) - shift(phi,-1,1,0))
dxdz = 0.5*(shift(phi,1,0,1) + shift(phi,-1,0,-1) - shift(phi,1,0,-1) - shift(phi,-1,0,1))
dydz = 0.5*(shift(phi,0,1,1) + shift(phi,0,-1,-1) - shift(phi,0,1,-1) - shift(phi,0,-1,1))
; obtain density by differencing potential
rho  = ddx + ddy + ddz

; write density field by plane to file
;write_planes,'tmp/','rho',rho
write_dens,'Data/',density_file,rho
if key(' density written plane by plane, and in one go') then stop


; reads all derivatives from files
dirname = './'
readfield,'d2phi_dx2.d',lx,ly,lz,ddx_fftw,/double & print,' ddx: ',minmax(abs(ddx-ddx_fftw))
readfield,'d2phi_dy2.d',lx,ly,lz,ddy_fftw,/double & print,' ddy: ',minmax(abs(ddy-ddy_fftw)) 
readfield,'d2phi_dz2.d',lx,ly,lz,ddy_fftw,/double & print,' ddx: ',minmax(abs(ddx-ddx_fftw)) 
readfield,'d2phi_dxdy.d',lx,ly,lz,dxdy_fftw,/double & print,' dxdy: ',minmax(abs(dxdy-dxdy_fftw)) 
readfield,'d2phi_dxdz.d',lx,ly,lz,dxdz_fftw,/double & print,' dxdz: ',minmax(abs(dxdz-dxdz_fftw)) 
readfield,'d2phi_dydz.d',lx,ly,lz,dydz_fftw,/double & print,' dydz: ',minmax(abs(dydz-dydz_fftw)) 
;
readfield,'dphi_dx.d',lx,ly,lz,dx_fftw,/double & print,' dx: ',minmax(abs(dx-dx_fftw)) 
readfield,'dphi_dy.d',lx,ly,lz,dy_fftw,/double & print,' dy: ',minmax(abs(dy-dy_fftw)) 
readfield,'dphi_dz.d',lx,ly,lz,dz_fftw,/double & print,' dz: ',minmax(abs(dz-dz_fftw)) 
;
;readfield,'density.d',lx,ly,lz,rho_fftw & print,' rho: ',minmax(abs(rho-rho_fftw))
;readfield,'phi.d',lx,ly,lz,phi_fftw,/slice & print,' potential: ',minmax(abs(phi-phi_fftw))
;readfield,'dphi_dz.d',lx,ly,lz,dz_fftw,/slice & print,' dphi_dz: ',minmax(abs(dz-dz_fftw))
; ; readfield,dirname + 'd2phi_dxdy.d',Lx,Ly,Lz,d2phi_dxdy
; ; readfield,dirname + 'd2phi_dxdz.d',Lx,Ly,Lz,d2phi_dxdz
; ; readfield,dirname + 'd2phi_dydz.d',Lx,Ly,Lz,d2phi_dydz
; readfield,dirname + 'd2phi_dx2.d', Lx,Ly,Lz,ddx_fftw & print,' ddx: ',minmax(abs(ddx-ddx_fftw))
; readfield,dirname + 'd2phi_dy2.d', Lx,Ly,Lz,ddy_fftw & print,' ddy: ',minmax(abs(ddy-ddy_fftw))
; readfield,dirname + 'd2phi_dz2.d', Lx,Ly,Lz,ddz_fftw & print,' ddz: ',minmax(abs(ddz-ddz_fftw))
; readfield,dirname + 'density.d',Lx,Ly,Lz,rho_fftw & print,' density: ',minmax(abs(rho-rho_fftw))


stop
; complex fft of phi
phihat = fft(phi,/double)

; obtain same quantities by convolving
kvect_z = 2.d0*!dpi*double(fft_findgen(Lz))/double(lz)
kvect_y = 2.d0*!dpi*double(fft_findgen(Ly))/double(ly)
kvect_x = 2.d0*!dpi*double(fft_findgen(lx))/double(lx)

; convolve
rhoG = phihat
dxG  = phihat
dyG  = phihat
dzG  = phihat
ddxG = phihat
ddyG = phihat
ddzG = phihat
dxdyG = phihat
dxdzG = phihat
dydzG = phihat
for iz=0,Lz-1 do begin $
  & kz = kvect_z[iz] $
  & for iy=0,ly-1 do begin $
  & ky = kvect_y[iy] $
  & for ix=0,lx-1 do begin $
  & kx = kvect_x[ix] $
; density
  & green = 2.d0*(cos(kx)-1.d0) + 2.d0*(cos(ky)-1.d0) +  2.d0*(cos(kz)-1.d0) $
  & rhoG[ix,iy,iz]  = green*rhoG[ix,iy,iz] $

; second derivatives
  & green = 2.d0*(cos(kx)-1.d0) & ddxG[ix,iy,iz] = green * ddxG[ix,iy,iz]  $
  & green = 2.d0*(cos(ky)-1.d0) & ddyG[ix,iy,iz] = green * ddyG[ix,iy,iz]  $
  & green = 2.d0*(cos(kz)-1.d0) & ddzG[ix,iy,iz] = green * ddzG[ix,iy,iz]  $
  & green = -2.d0*sin(kx)*sin(ky)     & dxdyG[ix,iy,iz]  = green * dxdyG[ix,iy,iz] $
  & green = -2.d0*sin(kx)*sin(kz)     & dxdzG[ix,iy,iz]  = green * dxdzG[ix,iy,iz] $
  & green = -2.d0*sin(ky)*sin(kz)     & dydzG[ix,iy,iz]  = green * dydzG[ix,iy,iz] $
; first derivatives
  & green = sin(kx)             & dxG[ix,iy,iz]  = green * dxG[ix,iy,iz] $
  & green = sin(ky)             & dyG[ix,iy,iz]  = green * dyG[ix,iy,iz] $
  & green = sin(kz)             & dzG[ix,iy,iz]  = green * dzG[ix,iy,iz] $
         & endfor $
         & endfor $
         & endfor

; ; compare results from differentiation with those from convolution
; print,'Comparing idl-generated derivatives, grid vs fft'
; rhoG = double(fft(rhoG,/inverse,/double))     & print,' rho ',minmax(abs(rho-rhoG))
; ddxG = double(fft(ddxG,/inverse,/double))     & print,' ddx ',minmax(abs(ddx-ddxG))
; ddyG = double(fft(ddyG,/inverse,/double))     & print,' ddy ',minmax(abs(ddy-ddyG))
; ddzG = double(fft(ddzG,/inverse,/double))     & print,' ddz ',minmax(abs(ddz-ddzG))
; dxdyG = double(fft(dxdyG,/inverse,/double))   & print,' dxdy ',minmax(abs(dxdy-dxdyG))
; dxdzG = double(fft(dxdzG,/inverse,/double))   & print,' dxdz ',minmax(abs(dxdz-dxdzG))
; dydzG = double(fft(dydzG,/inverse,/double))   & print,' dydz ',minmax(abs(dydz-dydzG))
; ;
; dxG  = -imaginary(fft(dxG,/inverse,/double))  & print,' dx  ',minmax(abs(dx-dxG))
; dyG  = -imaginary(fft(dyG,/inverse,/double))  & print,' dy  ',minmax(abs(dy-dyG))
; dzG  = -imaginary(fft(dzG,/inverse,/double))  & print,' dz  ',minmax(abs(dz-dzG))     

; now read results from fftw and do the same
test_dir = '/home/simulate/Codes/Pinocchio/Pinocchio-2.2/rundir/prova0/tmp/'
rho_fmax = readtest(test_dir,'density')
phi_fmax = readtest(test_dir,'potential')
print,' input density: ',minmax(abs(rho-rho_fmax))
print,' potential:     ',minmax(abs(phi-phi_fmax))
stop


print,'Comparing fmax-generated derivatives with idl-generated ones'
;print,' rho ',minmax(abs(rho-den))   
print,' ddx ',minmax(abs(ddx-d2phi_dx2))   
print,' ddy ',minmax(abs(ddy-d2phi_dy2))   
print,' ddz ',minmax(abs(ddz-d2phi_dz2))   
print,' dxdy ',minmax(abs(dxdy-d2phi_dxdy))
print,' dxdz ',minmax(abs(dxdz-d2phi_dxdz))
print,' dydz ',minmax(abs(dydz-d2phi_dydz))
                                                                                     
;print,' dx  ',minmax(abs(dx-dphi_dx))     
;print,' dy  ',minmax(abs(dy-dphi_dy))     
;print,' dz  ',minmax(abs(dz-dphi_dz))     

z=findgen(Lz)
plot,z,rho[1,2,*],psym=10 & oplot,z,den[1,2,*],psym=4,color=red
;plot,den,(mydens-den),psym=3
