;*****************************************************************
;*                       PINOCCHI0  V2.2                         *
;*  (PINpointing Orbit-Crossing Collapsed HIerarchical Objects)  *
;*****************************************************************
;
;This code was written by
;Pierluigi Monaco, Tom Theuns, Giuliano Taffoni
;Copyright (C) 2008
;
;web page: http//adlibitum.oats.inaf.it/monaco/Homepage/Pinocchio/
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation; either version 2 of the License, or
;(at your option) any later version.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


function read_planes,nz,dir,name
;
file = dir + name + 'p' + string(1,format='(i4.4)') + '.d'
;spawn,' ls -1 ',dir+name
openr,unit,file,/get_lun,/f77_unformatted
nx = 0l & ny=0l ; & nz=0l ;& type=0l
readu,unit,nx,ny
close,unit
free_lun,unit

print,'reading field '+dir+name

dimen = [nx,ny,nz]
data  = dblarr(nx,ny,nz)
plane = dblarr(nx,ny)

;
for i=0,dimen(2)-1 do begin
    file = dir + name + 'p' + string(i,format='(i4.4)') + '.d'
    openr,unit,file,/get_lun,/f77_unformatted
;    print,' reading file ' + file
    nx = 0l & ny=0l
    readu,unit,nx,ny
    if(nx ne dimen[0] or ny ne dimen[1] or nz ne dimen[2]) then begin
        print,' error reading size array '
        stop
    endif
;    type = 0l
;    readu,unit,type
    readu,unit,plane
    data[*,*,i] = plane
    close,unit
    free_lun,unit
endfor
return,data
end
