;*****************************************************************
;*                       PINOCCHI0  V2.2                         *
;*  (PINpointing Orbit-Crossing Collapsed HIerarchical Objects)  *
;*****************************************************************
;
;This code was written by
;Pierluigi Monaco, Tom Theuns, Giuliano Taffoni
;Copyright (C) 2008
;
;web page: http//adlibitum.oats.inaf.it/monaco/Homepage/Pinocchio/
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation; either version 2 of the License, or
;(at your option) any later version.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


function readfield,filename,L1,L2,L3,slice=slice,double=double,hdf5=hdf5,old=old

; reads a field
if keyword_set(hdf5) then begin
    L1    = h5read(filename,'Grid/nx')
    L2    = h5read(filename,'Grid/ny')
    L3    = h5read(filename,'Grid/nz')
    field = h5read(filename,'Data/array')
endif else begin
    openu,unit,filename,/f77_unformatted,/get_lun
    if keyword_set(old) then a=1 else begin
        L1=0l & L2=0l & L3=0l
        readu,unit,L1,L2,L3
    endelse
    if keyword_set(double) then begin
        field = dblarr(L1,L2,L3)
        plane = dblarr(L1,L2)
    endif else begin
        field = fltarr(L1,L2,L3)
        plane = fltarr(L1,L2)
    endelse
    if keyword_set(slice) then begin
        for i=0,L3-1 do begin
            iplane = 0l
            readu,unit,iplane
            readu,unit,plane
            field[*,*,i] = plane[*,*]
;            print,' plane read ',i,iplane
        endfor
    endif else begin
        readu,unit,field
    endelse
    close,unit
    free_lun,unit
endelse
return,field
end
