;*****************************************************************
;*                       PINOCCHI0  V2.2                         *
;*  (PINpointing Orbit-Crossing Collapsed HIerarchical Objects)  *
;*****************************************************************
;
;This code was written by
;Pierluigi Monaco, Tom Theuns, Giuliano Taffoni
;Copyright (C) 2008
;
;web page: http//adlibitum.oats.inaf.it/monaco/Homepage/Pinocchio/
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation; either version 2 of the License, or
;(at your option) any later version.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
function readtest,test_dir,string
;
spawn,' ls -1 ' + test_dir + ' | grep ' + string,res
nfiles = n_elements(res)
;
openr,unit,test_dir + '/' + res[0],/f77_unformatted,/get_lun
Lx = 0l & Ly = 0l & Lz=0l
iz = 0l & i8= 0l
readu,unit,Lx,Ly,Lz
readu,unit,iz
readu,unit,i8
close,unit
free_lun,unit
if (i8 ne 4 and i8 ne 8) then begin
    print,' error, real type is ',i8
    stop
endif

;
if (i8 eq 8) then begin
    data  = dblarr(Lx,Ly,Lz)
    plane = dblarr(Lx,Ly)
endif else begin
    data  = fltarr(Lx,Ly,Lz)
    plane = fltarr(Lx,Ly)
endelse
iplane = intarr(Lz)
;
for i=0,nfiles-1 do begin
    nx = 0l & ny = 0l & nz=0l & iz = 0l
    openr,unit,test_dir + '/' + res[i],/f77_unformatted,/get_lun
    readu,unit,nx,ny,nz
    if(nx ne lx or ny ne ly or nz ne lz) then begin
        print,' error reading file ',res[i]
        stop
    endif
    readu,unit,iz
    iz = iz - 1 ; idl convention
    if(iplane(iz) ne 0) then begin
        print,' error : plane ',iz,' occurs twice ? '
        stop
    endif
    iplane[iz] = 1
    readu,unit,i8
    readu,unit,plane
    data[*,*,iz] = plane
    close,unit
    free_lun,unit
endfor
return,data
end

    
