;*****************************************************************
;*                       PINOCCHI0  V2.2                         *
;*  (PINpointing Orbit-Crossing Collapsed HIerarchical Objects)  *
;*****************************************************************
;
;This code was written by
;Pierluigi Monaco, Tom Theuns, Giuliano Taffoni
;Copyright (C) 2008
;
;web page: http//adlibitum.oats.inaf.it/monaco/Homepage/Pinocchio/
;
;This program is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation; either version 2 of the License, or
;(at your option) any later version.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


pro write_dens,dir,name,data
;
dimen = size(data,/dimen,/L64)
;

file = dir + name
openw,unit,file,/get_lun,/f77_unformatted
;writeu,unit,long(1)
;writeu,unit,double(2.0)
writeu,unit,long(dimen[0]),long(dimen[1]),long(dimen[2])
for i=0,dimen(2)-1 do begin
    writeu,unit,long(i)
    writeu,unit,double(data[*,*,i])
endfor
print,'written file '+file

close,unit
free_lun,unit
end


pro read_dens,dir,name,data
;
dimen=long(findgen(3))
file = dir + name
openr,unit,file,/get_lun,/f77_unformatted
readu,unit,dimen
data=dblarr(dimen)
plane=dblarr(dimen[0],dimen[1])
for i=0,dimen(2)-1 do begin
    readu,unit,i
    readu,unit,plane
    data[*,*,i]=plane
endfor
print,'read file '+file,dimen

close,unit
free_lun,unit
end


